import argparse
from os import system
import os 
import re
import random
import pathlib

ROOT_DIR = pathlib.Path(__file__).parent.absolute()


def create_blif_file():
    yosys_script = opdir + "/yosys_script.ys"

    file_handle = open(yosys_script,'w')

    script_commands = ""

    script_commands += "read_liberty " + lib + "\n"
    script_commands += "read_verilog " + design + "\n"
    script_commands += "flatten; opt -fast;\n"
    script_commands += "synth -top " + top + "\n"
    script_commands += "write_blif " + opdir + "/" + top + ".blif" + "\n"

    file_handle.write(script_commands)
    file_handle.close()

    exe_commands = f"{ROOT_DIR}/yosys/yosys " + yosys_script + " > " + opdir + "/yosys.log"
    print(exe_commands)
    system(exe_commands)

def create_bench_file():

    abc_script = opdir + "/abc_script.tcl"

    file_handle = open(abc_script,'w')

    blif_file = opdir + "/" + top + ".blif"
    
    script_commands = ""

    script_commands += "read_blif " + blif_file + "\n"
    script_commands += "strash" + "\n"
    script_commands += "write_bench -l " + opdir + "/" + top + ".bench" + "\n"
    script_commands += "quit" + "\n"

    file_handle.write(script_commands)
    file_handle.close()

    exe_commands = f"{ROOT_DIR}/abc/abc -f " + abc_script + " > " + opdir + "/abc.log"
    print(exe_commands)
    system(exe_commands)


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="To get .bench format file")
    parser.add_argument("-lib", "--lib",  required=True, help="Library file in .lib format")
    parser.add_argument("-design", "--design",  required=True, help="verilog design")
    parser.add_argument("-opdir", "--opdir",  required=True, help="Output directory")
    parser.add_argument("-top", "--top",  required=True, help="Top module")

    args = parser.parse_args()

    lib = args.lib
    design = args.design
    opdir = args.opdir
    top = args.top
    
    if(os.path.exists(opdir) == 0):
        os.mkdir(opdir)

    create_blif_file()

    create_bench_file()

    
