# Install shared dependencies
echo "[INFO] Installing shared dependencies"
sudo apt-get install gcc g++ make perl git vim -y
echo "[INFO] Installed shared dependencies"


# Install Yosys dependencies
echo "[INFO] Installing Yosys dependencies"
sudo apt-get install build-essential clang bison flex libreadline-dev gawk tcl-dev libffi-dev git graphviz xdot pkg-config python3 libboost-system-dev libboost-python-dev libboost-filesystem-dev zlib1g-dev -y
echo "[INFO] Installed Yosys dependencies"


# Install PSAT dependencies
echo "[INFO] Installing PSAT dependencies"
sudo apt-get install libfl2 -y
echo "[INFO] Installed PSAT dependencies"


# Install Yosys
echo "[INFO] Installing Yosys"
git clone https://github.com/YosysHQ/yosys.git
cd yosys
make config-clang
make
sudo make install
cd
echo "[INFO] Installed Yosys"


# Install ABC Compiler
echo "[INFO] Installing ABC Compiler"
git clone https://github.com/berkeley-abc/abc.git
cd abc
make
cd
echo "[INFO] Installed ABC Compiler"


# Clone PSAT repository
echo "[INFO] Cloning PSAT repository"
git clone https://github.com/DfX-NYUAD/PSAT.git
echo "[INFO] Cloned PSAT repository"

