import argparse
from os import system
import os 
import re
import random
import subprocess
from pathlib import Path
import pathlib

ROOT_DIR = pathlib.Path(__file__).parent.absolute()


def match_pi():
    orig_bench = opdir + "/orig_bench/" + top + ".bench"
    lock_bench = opdir + "/lock_bench/" + top + ".bench"

    orig_PI_list = []
    orig_PO_list = []
    with open(orig_bench, 'r') as filehandle:
        lines = filehandle.readlines()
        for i in range(0, len(lines)):
            line = lines[i]
            if("INPUT" in line):
                data = re.search(r'\((.*?)\)',line).group(1)
                orig_PI_list.append(data)
            if("OUTPUT" in line):
                data = re.search(r'\((.*?)\)',line).group(1)
                orig_PO_list.append(data)
        
    lock_PI_list = []
    with open(lock_bench, 'r') as filehandle:
        lines = filehandle.readlines()
        for i in range(0, len(lines)):
            line = lines[i]
            if("INPUT" in line):
                data = re.search(r'\((.*?)\)',line).group(1)
                lock_PI_list.append(data)
    
    lock_mod_bench = opdir + "/lock_bench/" + top + "_mod.bench"

    lock_handle = open(lock_mod_bench,'w')

    with open(lock_bench, 'r') as filehandle:
        lines = filehandle.readlines()

        lock_handle.write(lines[0])

        #writing out original PI
        for i in range(0, len(orig_PI_list)):
            temp_str = "INPUT(" + orig_PI_list[i] + ")\n"
            lock_handle.write(temp_str)

        #writing out original PO
        for i in range(0, len(orig_PO_list)):
            temp_str = "OUTPUT(" + orig_PO_list[i] + ")\n"
            lock_handle.write(temp_str)

        #writing out keyports
        for i in range(0, len(lock_PI_list)):
            data = lock_PI_list[i]
            if(data not in orig_PI_list):
                temp_str = "INPUT(" + data + ")\n"
                lock_handle.write(temp_str)
                
        for i in range(1, len(lines)):
            line = lines[i]
            if("INPUT" not in line and "OUTPUT" not in line):
                lock_handle.write(line)

    lock_handle.close()



if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="To run SAT attack")
    parser.add_argument("-opdir", "--opdir",  required=True, help="Output directory")
    parser.add_argument("-lib_orig", "--lib_orig",  required=True, help="Library file in .lib format for original design")
    parser.add_argument("-lib_locked", "--lib_locked",  required=True, help="Library file in .lib format for locked design")
    parser.add_argument("-orig_design", "--orig_design",  required=True, help="verilog design")
    parser.add_argument("-locked_design", "--locked_design",  required=True, help="locked verilog design")
    parser.add_argument("-top", "--top",  required=True, help="Top module")

    args = parser.parse_args()

    opdir = args.opdir
    lib_orig = args.lib_orig
    lib_locked = args.lib_locked
    orig_design = args.orig_design
    locked_design = args.locked_design
    top = args.top

    Path(opdir).mkdir(exist_ok=True, parents=True)
    
    lock_bench_opdir = opdir + "/lock_bench"
    orig_bench_opdir = opdir + "/orig_bench"

    lock_bench_script = ["python3", f"{ROOT_DIR}/get_bench.py", "-lib", lib_locked,"-design" , locked_design,"-opdir", lock_bench_opdir, "-top", top]

    command = " ".join(lock_bench_script)

    print("----------------------------------------")
    print("Converting locked design to bench format")
    print(command)
    system(command)

    orig_bench_script = ["python3", f"{ROOT_DIR}/get_bench.py", "-lib", lib_orig,"-design" , orig_design,"-opdir", orig_bench_opdir, "-top", top]

    command = " ".join(orig_bench_script)

    print("----------------------------------------")
    print("Converting original design to bench format")
    print(command)
    system(command)

    # match PI for SAT to work
    match_pi()

    sat_command = f"{ROOT_DIR}/PSAT/bin/sld " + opdir + "/lock_bench/" + top + "_mod.bench" + " " + opdir + "/orig_bench/" + top + ".bench" + " > " + opdir + "/sat.log"

    print("----------------------------------------")
    print("Running SAT attack [", opdir + "/sat.log" , "]")
    print(sat_command)
    system(sat_command)

    print("Done !!!")
